All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section ["parameter=[value]" ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It can checkout, update, or
32 perform other actions on a set of repositories as if they were one combined
33 respository. It supports any combination of subversion, git, cvs, mecurial,
34 bzr and darcs repositories, and support for other revision control systems can
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
111 To see the built-in library of shell functions contained in mr:
113 mr config DEFAULT lib
115 The ~/.mrconfig file is used by default. To use a different config file,
124 Actions can be abbreviated to any unambiguous subsctring, so
125 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
128 Additional parameters can be passed to most commands, and are passed on
129 unchanged to the underlying revision control system. This is mostly useful
130 if the repositories mr will act on all use the same revision control
139 Specifies the topmost directory that B<mr> should work in. The default is
140 the current working directory.
144 Use the specified mrconfig file. The default is B<~/.mrconfig>
152 Expand the statistics line displayed at the end to include information
153 about exactly which repositories failed and were skipped, if any.
157 Just operate on the repository for the current directory, do not
158 recurse into deeper repositories.
162 Run the specified number of jobs in parallel. This can greatly speed up
163 operations such as updates. It is not recommended for interactive
170 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
171 file in your home directory, and this can in turn chain load .mrconfig files
174 Here is an example .mrconfig file:
177 checkout = svn co svn://svn.example.com/src/trunk src
181 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
183 git checkout -b mybranch origin/master
185 The .mrconfig file uses a variant of the INI file format. Lines starting with
186 "#" are comments. Values can be continued to the following line by
187 indenting the line with whitespace.
189 The "DEFAULT" section allows setting default values for the sections that
192 The "ALIAS" section allows adding aliases for actions. Each parameter
193 is an alias, and its value is the action to use.
195 All other sections add repositories. The section header specifies the
196 directory where the repository is located. This is relative to the directory
197 that contains the mrconfig file, but you can also choose to use absolute
200 Within a section, each parameter defines a shell command to run to handle a
201 given action. mr contains default handlers for "update", "status",
202 "commit", and other standard actions. Normally you only need to specify what
203 to do for "checkout".
205 Note that these shell commands are run in a "set -e" shell
206 environment, where any additional parameters you pass are available in
207 "$@". The "checkout" command is run in the parent of the repository
208 directory, since the repository isn't checked out yet. All other commands
209 are run inside the repository, though not necessarily at the top of it.
211 The "MR_REPO" environment variable is set to the path to the top of the
212 repository. (For the "register" action, "MR_REPO" is instead set to the
213 basename of the directory that should be created when checking the
216 The "MR_CONFIG" environment variable is set to the .mrconfig file
217 that defines the repo being acted on, or, if the repo is not yet in a config
218 file, the .mrconfig file that should be modified to register the repo.
220 A few parameters have special meanings:
226 If the "skip" parameter is set and its command returns true, then B<mr>
227 will skip acting on that repository. The command is passed the action
230 Here are two examples. The first skips the repo unless
231 mr is run by joey. The second uses the hours_since function
232 (included in mr's built-in library) to skip updating the repo unless it's
233 been at least 12 hours since the last update.
235 skip = test $(whoami) != joey
236 skip = [ "$1" = update ] && ! hours_since "$1" 12
240 The "order" parameter can be used to override the default ordering of
241 repositories. The default order value is 10. Use smaller values to make
242 repositories be processed earlier, and larger values to make repositories
245 Note that if a repository is located in a subdirectory of another
246 repository, ordering it to be processed earlier is not recommended.
250 If the "chain" parameter is set and its command returns true, then B<mr>
251 will try to load a .mrconfig file from the root of the repository. (You
252 should avoid chaining from repositories with untrusted committers.)
256 If the "include" parameter is set, its command is ran, and should output
257 additional mrconfig file content. The content is included as if it were
258 part of the including file.
260 Unlike all other parameters, this parameter does not need to be placed
265 The "lib" parameter can specify some shell code that will be run before each
266 command, this can be a useful way to define shell functions for other commands
271 When looking for a command to run for a given action, mr first looks for
272 a parameter with the same name as the action. If that is not found, it
273 looks for a parameter named "rcs_action" (substituting in the name of the
274 revision control system and the action). The name of the revision control
275 system is itself determined by running each defined "rcs_test" action,
278 Internally, mr has settings for "git_update", "svn_update", etc. To change
279 the action that is performed for a given revision control system, you can
280 override these rcs specific actions. To add a new revision control system,
281 you can just add rcs specific actions for it.
285 Copyright 2007 Joey Hess <joey@kitenet.net>
287 Licensed under the GNU GPL version 2 or higher.
289 http://kitenet.net/~joey/code/mr/
298 use Cwd qw(getcwd abs_path);
300 # things that can happen when mr runs a command
309 my $config_overridden=0;
315 my $directory=getcwd();
322 my (@ok, @failed, @skipped);
327 my ($action, $dir, $topdir, $subdir) = @_;
330 foreach my $rcs_test (
332 length $a <=> length $b
335 } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
336 my ($rcs)=$rcs_test=~/(.*)_test/;
337 $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
338 $test.="if my_$rcs_test; then echo $rcs; fi\n";
340 $test=$config{$topdir}{$subdir}{lib}."\n".$test
341 if exists $config{$topdir}{$subdir}{lib};
343 print "mr $action: running rcs test >>$test<<\n" if $verbose;
354 sub findcommand { #{{{
355 my ($action, $dir, $topdir, $subdir) = @_;
357 if (exists $config{$topdir}{$subdir}{$action}) {
358 return $config{$topdir}{$subdir}{$action};
361 my $rcs=rcs_test(@_);
364 exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
365 return $config{$topdir}{$subdir}{$rcs."_".$action};
373 my ($action, $dir, $topdir, $subdir) = @_;
375 $ENV{MR_CONFIG}=$configfiles{$topdir};
376 my $lib=exists $config{$topdir}{$subdir}{lib} ?
377 $config{$topdir}{$subdir}{lib}."\n" : "";
379 if ($action eq 'checkout') {
381 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
385 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
388 print "mr $action: creating parent directory $dir\n" if $verbose;
389 system("mkdir", "-p", $dir);
392 elsif ($action =~ /update/) {
394 return action("checkout", $dir, $topdir, $subdir);
400 my $skiptest=findcommand("skip", $dir, $topdir, $subdir);
401 my $command=findcommand($action, $dir, $topdir, $subdir);
403 if (defined $skiptest) {
404 my $test="set -e;".$lib.
405 "my_action(){ $skiptest\n }; my_action '$action'";
406 print "mr $action: running skip test >>$test<<\n" if $verbose;
407 my $ret=system($test);
409 if (($? & 127) == 2) {
410 print STDERR "mr $action: interrupted\n";
414 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
418 if ($ret >> 8 == 0) {
419 print "mr $action: $dir skipped per config file\n" if $verbose;
424 if (! $no_chdir && ! chdir($dir)) {
425 print STDERR "mr $action: failed to chdir to $dir: $!\n";
428 elsif (! defined $command) {
429 my $rcs=rcs_test(@_);
430 if (! defined $rcs) {
431 print STDERR "mr $action: unknown repository type and no defined $action command for $topdir$subdir\n";
435 print STDERR "mr $action: no defined $action command for $rcs repository $topdir$subdir, skipping\n";
441 print "mr $action: $topdir$subdir\n";
445 $s=~s/^\Q$topdir$subdir\E\/?//;
446 print "mr $action: $topdir$subdir (in subdir $s)\n";
448 $command="set -e; ".$lib.
449 "my_action(){ $command\n }; my_action ".
450 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
451 print "mr $action: running >>$command<<\n" if $verbose;
452 my $ret=system($command);
454 if (($? & 127) == 2) {
455 print STDERR "mr $action: interrupted\n";
459 print STDERR "mr $action: received signal ".($? & 127)."\n";
462 print STDERR "mr $action: failed ($ret)\n" if $verbose;
463 if ($ret >> 8 != 0) {
464 print STDERR "mr $action: command failed\n";
467 print STDERR "mr $action: command died ($ret)\n";
472 if ($action eq 'checkout' && ! -d $dir) {
473 print STDERR "mr $action: $dir missing after checkout\n";;
482 # run actions on multiple repos, in parallel
492 while (@fhs or @repos) {
493 while ($running < $jobs && @repos) {
495 my $repo = shift @repos;
496 pipe(my $outfh, CHILD_STDOUT);
497 pipe(my $errfh, CHILD_STDERR);
499 unless ($pid = fork) {
500 die "mr $action: cannot fork: $!" unless defined $pid;
501 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
502 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
507 exit action($action, @$repo);
511 push @active, [$pid, $repo];
512 push @fhs, [$outfh, $errfh];
515 my ($rin, $rout) = ('','');
517 foreach my $fh (@fhs) {
518 next unless defined $fh;
519 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
520 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
522 $nfound = select($rout=$rin, undef, undef, 1);
523 foreach my $channel (0, 1) {
524 foreach my $i (0..$#fhs) {
525 next unless defined $fhs[$i];
526 my $fh = $fhs[$i][$channel];
527 next unless defined $fh;
528 if (vec($rout, fileno($fh), 1) == 1) {
530 if (sysread($fh, $r, 1024) == 0) {
532 $fhs[$i][$channel] = undef;
533 if (! defined $fhs[$i][0] &&
534 ! defined $fhs[$i][1]) {
535 waitpid($active[$i][0], 0);
536 print STDOUT $out[$i][0];
537 print STDERR $out[$i][1];
538 record($active[$i][1], $? >> 8);
540 splice(@active, $i, 1);
545 $out[$i][$channel] .= $r;
553 my $dir=shift()->[0];
560 elsif ($ret == FAILED) {
564 elsif ($ret == SKIPPED) {
567 elsif ($ret == ABORT) {
571 die "unknown exit status $ret";
577 if (! @ok && ! @failed && ! @skipped) {
578 die "mr $action: no repositories found to work on\n";
580 print "mr $action: finished (".join("; ",
581 showstat($#ok+1, "ok", "ok"),
582 showstat($#failed+1, "failed", "failed"),
583 showstat($#skipped+1, "skipped", "skipped"),
587 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
590 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
600 return "$count ".($count > 1 ? $plural : $singular);
605 # an ordered list of repos
608 foreach my $topdir (sort keys %config) {
609 foreach my $subdir (sort keys %{$config{$topdir}}) {
613 order => $config{$topdir}{$subdir}{order},
618 $a->{order} <=> $b->{order}
620 $a->{topdir} cmp $b->{topdir}
622 $a->{subdir} cmp $b->{subdir}
626 # figure out which repos to act on
627 sub selectrepos { #{{{
629 foreach my $repo (repolist()) {
630 my $topdir=$repo->{topdir};
631 my $subdir=$repo->{subdir};
633 next if $subdir eq 'DEFAULT';
634 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
636 $dir.="/" unless $dir=~/\/$/;
637 $d.="/" unless $d=~/\/$/;
638 next if $no_recurse && $d ne $dir;
639 next if $dir ne $d && $dir !~ /^\Q$d\E/;
640 push @repos, [$dir, $topdir, $subdir];
643 # fallback to find a leaf repo
644 foreach my $repo (reverse repolist()) {
645 my $topdir=$repo->{topdir};
646 my $subdir=$repo->{subdir};
648 next if $subdir eq 'DEFAULT';
649 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
651 $dir.="/" unless $dir=~/\/$/;
652 $d.="/" unless $d=~/\/$/;
653 if ($d=~/^\Q$dir\E/) {
654 push @repos, [$dir, $topdir, $subdir];
664 sub loadconfig { #{{{
671 if (ref $f eq 'GLOB') {
680 my $absf=abs_path($f);
681 if ($loaded{$absf}) {
686 ($dir)=$f=~/^(.*\/)[^\/]+$/;
687 if (! defined $dir) {
690 $dir=abs_path($dir)."/";
692 if (! exists $configfiles{$dir}) {
693 $configfiles{$dir}=$f;
696 # copy in defaults from first parent
698 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
699 if ($parent eq '/') {
702 if (exists $config{$parent} &&
703 exists $config{$parent}{DEFAULT}) {
704 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
709 print "mr: loading config $f\n" if $verbose;
710 open($in, "<", $f) || die "mr: open $f: $!\n";
721 next if /^\s*\#/ || /^\s*$/;
722 if (/^\[([^\]]*)\]\s*$/) {
725 elsif (/^(\w+)\s*=\s*(.*)/) {
730 while (@lines && $lines[0]=~/^\s(.+)/) {
737 if ($parameter eq "include") {
738 print "mr: including output of \"$value\"\n" if $verbose;
739 unshift @lines, `$value`;
743 if (! defined $section) {
744 die "$f line $.: parameter ($parameter) not in section\n";
746 if ($section ne 'ALIAS' &&
747 ! exists $config{$dir}{$section} &&
748 exists $config{$dir}{DEFAULT}) {
750 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
752 if ($section eq 'ALIAS') {
753 $alias{$parameter}=$value;
755 elsif ($parameter eq 'lib') {
756 $config{$dir}{$section}{lib}.=$value."\n";
759 $config{$dir}{$section}{$parameter}=$value;
760 if ($parameter =~ /.*_(.*)/) {
764 $knownactions{$parameter}=1;
766 if ($parameter eq 'chain' &&
767 length $dir && $section ne "DEFAULT" &&
768 -e $dir.$section."/.mrconfig") {
769 my $ret=system($value);
771 if (($? & 127) == 2) {
772 print STDERR "mr: chain test interrupted\n";
776 print STDERR "mr: chain test received signal ".($? & 127)."\n";
780 push @toload, $dir.$section."/.mrconfig";
786 die "$f line $line: parse error\n";
795 sub modifyconfig { #{{{
797 # the section to modify or add
798 my $targetsection=shift;
799 # fields to change in the section
800 # To remove a field, set its value to "".
807 open(my $in, "<", $f) || die "mr: open $f: $!\n";
812 my $formatfield=sub {
814 my @value=split(/\n/, shift);
816 return "$field = ".shift(@value)."\n".
817 join("", map { "\t$_\n" } @value);
821 while ($out[$#out] =~ /^\s*$/) {
822 unshift @blanks, pop @out;
824 foreach my $field (sort keys %changefields) {
825 if (length $changefields{$field}) {
826 push @out, "$field = $changefields{$field}\n";
827 delete $changefields{$field};
837 if (/^\s*\#/ || /^\s*$/) {
840 elsif (/^\[([^\]]*)\]\s*$/) {
841 if (defined $section &&
842 $section eq $targetsection) {
850 elsif (/^(\w+)\s*=\s(.*)/) {
855 while (@lines && $lines[0]=~/^\s(.+)/) {
861 if ($section eq $targetsection) {
862 if (exists $changefields{$parameter}) {
863 if (length $changefields{$parameter}) {
864 $value=$changefields{$parameter};
866 delete $changefields{$parameter};
870 push @out, $formatfield->($parameter, $value);
874 if (defined $section &&
875 $section eq $targetsection) {
878 elsif (%changefields) {
879 push @out, "\n[$targetsection]\n";
880 foreach my $field (sort keys %changefields) {
881 if (length $changefields{$field}) {
882 push @out, $formatfield->($field, $changefields{$field});
887 open(my $out, ">", $f) || die "mr: write $f: $!\n";
895 # actions that do not operate on all repos
896 if ($action eq 'help') {
899 elsif ($action eq 'config') {
902 elsif ($action eq 'register') {
907 mrs($action, selectrepos());
910 foreach my $repo (selectrepos()) {
911 record($repo, action($action, @$repo));
917 exec($config{''}{DEFAULT}{help}) || die "exec: $!";
922 die "mr config: not enough parameters\n";
925 if ($section=~/^\//) {
926 # try to convert to a path relative to the config file
927 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
929 $dir.="/" unless $dir=~/\/$/;
930 if ($section=~/^\Q$dir\E(.*)/) {
936 if (/^([^=]+)=(.*)$/) {
937 $changefields{$1}=$2;
941 foreach my $topdir (sort keys %config) {
942 if (exists $config{$topdir}{$section} &&
943 exists $config{$topdir}{$section}{$_}) {
944 print $config{$topdir}{$section}{$_}."\n";
946 last if $section eq 'DEFAULT';
950 die "mr config: $section $_ not set\n";
954 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
959 if (! $config_overridden) {
960 # Find the closest known mrconfig file to the current
962 $directory.="/" unless $directory=~/\/$/;
964 foreach my $topdir (reverse sort keys %config) {
965 next unless length $topdir;
966 if ($directory=~/^\Q$topdir\E/) {
967 $ENV{MR_CONFIG}=$configfiles{$topdir};
973 if (! $foundconfig) {
974 $directory=""; # no config file, use builtin
978 my $subdir=shift @ARGV;
979 if (! chdir($subdir)) {
980 print STDERR "mr register: failed to chdir to $subdir: $!\n";
984 $ENV{MR_REPO}=getcwd();
985 my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT');
986 if (! defined $command) {
987 die "mr register: unknown repository type\n";
990 $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
991 $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
992 "my_action(){ $command\n }; my_action ".
993 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
994 print "mr register: running >>$command<<\n" if $verbose;
995 exec($command) || die "exec: $!";
998 # alias expansion and command stemming
999 sub expandaction { #{{{
1001 if (exists $alias{$action}) {
1002 $action=$alias{$action};
1004 if (! exists $knownactions{$action}) {
1005 my @matches = grep { /^\Q$action\E/ }
1006 keys %knownactions, keys %alias;
1007 if (@matches == 1) {
1008 $action=$matches[0];
1010 elsif (@matches == 0) {
1011 die "mr: unknown action \"$action\" (known actions: ".
1012 join(", ", sort keys %knownactions).")\n";
1015 die "mr: ambiguous action \"$action\" (matches: ".
1016 join(", ", @matches).")\n";
1023 Getopt::Long::Configure("bundling", "no_permute");
1024 my $result=GetOptions(
1025 "d|directory=s" => sub { $directory=abs_path($_[1]) },
1026 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
1027 "v|verbose" => \$verbose,
1028 "s|stats" => \$stats,
1029 "n|no-recurse" => \$no_recurse,
1030 "j|jobs=i" => \$jobs,
1032 if (! $result || @ARGV < 1) {
1033 die("Usage: mr [-d directory] action [params ...]\n".
1034 "(Use mr help for man page.)\n");
1040 print STDERR "mr: interrupted\n";
1044 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
1046 # This can happen if it's run in a directory that was removed
1047 # or other strangeness.
1048 if (! defined $directory) {
1049 die("mr: failed to determine working directory\n");
1051 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
1052 # the config file might be a symlink to elsewhere, and the directory it's
1053 # in is significant.
1054 if ($ENV{MR_CONFIG} !~ /^\//) {
1055 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
1057 # Try to set MR_PATH to the path to the program.
1059 use FindBin qw($Bin $Script);
1060 $ENV{MR_PATH}=$Bin."/".$Script;
1068 loadconfig($ENV{MR_CONFIG});
1069 #use Data::Dumper; print Dumper(\%config);
1071 my $action=expandaction(shift @ARGV);
1078 elsif (! @ok && @skipped) {
1086 # Finally, some useful actions that mr knows about by default.
1087 # These can be overridden in ~/.mrconfig.
1103 echo "mr (warning): $@" >&2
1109 if [ -z "$1" ] || [ -z "$2" ]; then
1110 error "mr: usage: hours_since action num"
1112 for dir in .git .svn .bzr CVS .hg _darcs; do
1113 if [ -e "$MR_REPO/$dir" ]; then
1114 flagfile="$MR_REPO/$dir/.mr_last$1"
1118 if [ -z "$flagfile" ]; then
1119 error "cannot determine flag filename"
1121 delta=$(perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile")
1122 if [ "$delta" -lt "$2" ]; then
1130 svn_test = test -d "$MR_REPO"/.svn
1131 git_test = test -d "$MR_REPO"/.git
1132 bzr_test = test -d "$MR_REPO"/.bzr
1133 cvs_test = test -d "$MR_REPO"/CVS
1134 hg_test = test -d "$MR_REPO"/.hg
1135 darcs_test = test -d "$MR_REPO"/_darcs
1137 test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
1138 test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
1139 test "$(GIT_CONFIG="$MR_REPO"/config git config --get core.bare)" = true
1141 svn_update = svn update "$@"
1142 git_update = if [ "$@" ]; then git pull "$@"; else git pull -t origin master; fi
1143 bzr_update = bzr merge "$@"
1144 cvs_update = cvs update "$@"
1145 hg_update = hg pull "$@" && hg update "$@"
1146 darcs_update = darcs pull -a "$@"
1148 svn_status = svn status "$@"
1149 git_status = git status "$@" || true
1150 bzr_status = bzr status "$@"
1151 cvs_status = cvs status "$@"
1152 hg_status = hg status "$@"
1153 darcs_status = darcs whatsnew -ls "$@"
1155 svn_commit = svn commit "$@"
1156 git_commit = git commit -a "$@" && git push --all
1157 bzr_commit = bzr commit "$@" && bzr push
1158 cvs_commit = cvs commit "$@"
1159 hg_commit = hg commit -m "$@" && hg push
1160 darcs_commit = darcs commit -a -m "$@" && darcs push -a
1162 svn_diff = svn diff "$@"
1163 git_diff = git diff "$@"
1164 bzr_diff = bzr diff "$@"
1165 cvs_diff = cvs diff "$@"
1166 hg_diff = hg diff "$@"
1167 darcs_diff = darcs diff "$@"
1169 svn_log = svn log "$@"
1170 git_log = git log "$@"
1171 bzr_log = bzr log "$@"
1172 cvs_log = cvs log "$@"
1173 hg_log = hg log "$@"
1174 darcs_log = darcs changes "$@"
1175 git_bare_log = git log "$@"
1178 url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
1179 if [ -z "$url" ]; then
1180 error "cannot determine svn url"
1182 echo "Registering svn url: $url in $MR_CONFIG"
1183 mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
1185 url="$(LANG=C git config --get remote.origin.url)" || true
1186 if [ -z "$url" ]; then
1187 error "cannot determine git url"
1189 echo "Registering git url: $url in $MR_CONFIG"
1190 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
1192 url=$(cat .bzr/branch/parent)
1193 if [ -z "$url" ]; then
1194 error "cannot determine bzr url"
1196 echo "Registering bzr url: $url in $MR_CONFIG"
1197 mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone '$url' '$MR_REPO'"
1199 repo=$(cat CVS/Repository)
1200 root=$(cat CVS/Root)
1201 if [ -z "$root" ]; then
1202 error "cannot determine cvs root"
1204 echo "Registering cvs repository $repo at root $root"
1205 mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
1207 url=$(hg showconfig paths.default)
1208 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1209 mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
1211 url=$(cat _darcs/prefs/defaultrepo)
1212 echo "Registering darcs repository $url in $MR_CONFIG"
1213 mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url'p '$MR_REPO'"
1215 url="$(LANG=C GIT_CONFIG=config git config --get remote.origin.url)" || true
1216 if [ -z "$url" ]; then
1217 error "cannot determine git url"
1219 echo "Registering git url: $url in $MR_CONFIG"
1220 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
1223 if [ ! -e "$MR_PATH" ]; then
1224 error "cannot find program path"
1226 (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
1230 ed = echo "A horse is a horse, of course, of course.."
1231 T = echo "I pity the fool."
1232 right = echo "Not found."
1235 # vim:sw=8:sts=0:ts=8:noet